<?php

namespace App\Filament\Exports;

use App\Models\EquipmentMaster;
use Filament\Actions\Exports\ExportColumn;
use Filament\Actions\Exports\Exporter;
use Filament\Actions\Exports\Models\Export;

class EquipmentMasterExporter extends Exporter
{
    protected static ?string $model = EquipmentMaster::class;

    public static function getColumns(): array
    {
        static $rowNumber = 0;
        return [
           ExportColumn::make('no')
                ->label('NO')
                ->state(function ($record) use (&$rowNumber) {
                    // Increment and return the row number
                    return ++$rowNumber;
                }),
            ExportColumn::make('plant.name')
            ->label('PLANT'),
            ExportColumn::make('machine.name')
            ->label('MACHINE NAME'),
            ExportColumn::make('name')
            ->label('NAME'),
            ExportColumn::make('description')
            ->label('DESCRIPTION'),
            ExportColumn::make('make')
            ->label('MAKE'),
            ExportColumn::make('model')
            ->label('MODEL'),
            ExportColumn::make('equipment_number')
            ->label('EQUIPMENT NUMBER'),
            ExportColumn::make('instrument_serial_number')
            ->label('INSTRUMENT SERIAL NUMBER'),
            ExportColumn::make('calibrated_on')
            ->label('CALIBRATED ON'),
            ExportColumn::make('frequency')
            ->label('FREQUENCY'),
            ExportColumn::make('next_calibration_date')
            ->label('NEXT CALIBRATION DATE'),
            ExportColumn::make('calibrated_by')
            ->label('CALIBRATED BY'),
            ExportColumn::make('calibration_certificate')
            ->label('CALIBRATION CERTIFICATE'),
            ExportColumn::make('created_at')
            ->label('CREATED AT'),
            ExportColumn::make('updated_at')
            ->label('UPDATED AT'),
            ExportColumn::make('created_by')
            ->label('CREATED BY'),
            ExportColumn::make('updated_by')
            ->label('UPDATED BY'),
            ExportColumn::make('deleted_at')
            ->label('DELETED AT')
            ->enabledByDefault(false),
        ];
    }

    public static function getCompletedNotificationBody(Export $export): string
    {
        $body = 'Your equipment master export has completed and ' . number_format($export->successful_rows) . ' ' . str('row')->plural($export->successful_rows) . ' exported.';

        if ($failedRowsCount = $export->getFailedRowsCount()) {
            $body .= ' ' . number_format($failedRowsCount) . ' ' . str('row')->plural($failedRowsCount) . ' failed to export.';
        }

        return $body;
    }
}
